using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MeasureData;
using System.Configuration;
using FileManager;
using System.IO;
using System.Runtime.InteropServices;
using System.Diagnostics;

//20201029：注释
//初始化窗口管理的是参数，包括，测量文件使用的参数，配置文件中的参数（默认参数），或者保存成参数文件。
//初始化窗口中显示的参数是测量文件在使用的参数。
//点击确认，对当前修改的参数保存到测量文件中去。
//点击保存默认设置，当前修改的参数保存到AppConfig中，下次打开时作为默认值打开。
//点击保存成配置文件，将以文件的形式将参数保存在文件中
//参数又分为两种类型，客户操作可见的类型，在AppConfig中参数，
//客户操作的参数，可以每次都针对测量进行修改
//这类参数包括：
//是否是倾斜的样品台
//是否仅拍照
//是否使用PT
//PT加工文件
//FIB加工文件
//样品名称
//厂商
//拉直操作的放大倍数
//定位的电压
//定位的放大倍数
//拍照的电压
//拍照的放大倍数
//AppConfig中的参数，通常不需要修改，每次修改要在配置文件中修改，要重新启动程序
//这类参数包括：
//四组对焦参数
//Z轴的移动距离
//各个参数需要有一系列的默认值，并且各个值可以修改，删除

namespace HOZProject
{
    public partial class UControl_Init : UserControl
    {
        #region 成员变量

        //可供选择的各个参数的值列表
       
        String[] firms;//厂商列表
     

        //配置文件
        Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);

        //依附与主工作窗口
        private FormHOZMain formHOZMain;
        public FormHOZMain FormHOZMainObject { get => formHOZMain; set => formHOZMain = value; }
        
        //模板路径
        private string readConfigPath;
        public string ReadConfigPath { get => readConfigPath; set => readConfigPath = value; }
        
        //模板文件默认路径
    
        #endregion

        #region 构造方法
        public UControl_Init(FormHOZMain formHOZ)
        {
            InitializeComponent();
            FormHOZMainObject = formHOZ;
        }
        #endregion

        #region 窗体加载
        private void UControl_Init_Load(object sender, EventArgs e)
        {
            //从配置文件中读取一系列的信息


            cbbWYP.Items.Clear();
            DirectoryInfo TheFolder = new DirectoryInfo(System.Environment.CurrentDirectory + "\\SampleTemplate");
            foreach (FileInfo fi in TheFolder.GetFiles())//遍历文件夹下所有文件
            {
                cbbWYP.Items.Add(fi.Name);
            }

            SetTypel();
        } 
        #endregion

        #region 关闭窗体
        private void btnClose_Click(object sender, EventArgs e)
        {
         

            Form fParent = this.ParentForm;
            fParent.Close();
        }
        #endregion

        #region 加载切孔文件，生成切孔列表
        private void btnCutHoleFile_Click(object sender, EventArgs e)
        {
            try
            {
                if (FormHOZMainObject.m_MeasureFile == null)
                {
                    MessageBox.Show("请新建一个测量文件！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    if (!FormHOZMainObject.m_MeasureFile.GetCutHolesFromFile(""))
                    {
                        MessageBox.Show("导入切孔失败！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    else
                    {
                        List<CutHole> ListCutHole = FormHOZMainObject.m_MeasureFile.ListCutHole;
                        //文件路径
                        string CutHoleFilePath = FormHOZMainObject.m_MeasureFile.CutHoleFilePath;
                        FormHOZMainObject.CreateCutHoleList(ListCutHole);
                        //显示导入的切孔数量
                        lblCutHoleCount.Text = string.Format("成功导入{0}个切孔", ListCutHole.Count);
                        tbCutHoleFilePath.Text = CutHoleFilePath;
                        //保存测量文件
                        if (Directory.Exists(FormHOZMainObject.m_MeasureFile.FilePath))
                        {
                            FormHOZMainObject.m_MeasureFile.Save();
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                NLog.LogManager.GetCurrentClassLogger().Error(ex.Message);
            }
        }
        private void pbCutHoleFile_Click(object sender, EventArgs e)
        {
           
        }
        #endregion

        #region 根据一个切孔文件,自动计算其他切孔信息
        /// <summary>
        /// 根据一个切孔,自动计算其他切孔信息
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 
        private void btnCutHoleAuto_Click(object sender, EventArgs e)
        {
            try
            {
                if (FormHOZMainObject.m_MeasureFile == null)
                {
                    MessageBox.Show("请新建一个测量文件！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    if (!FormHOZMainObject.m_MeasureFile.GetCutHolesFromFile(""))
                    {
                        MessageBox.Show("导入切孔失败！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    else
                    {
                        List<CutHole> ListCutHole = FormHOZMainObject.m_MeasureFile.ListCutHole;
                        if (ListCutHole != null)
                        {
                            if (ListCutHole.Count > 0)
                            {
                                //根据切孔文件的一个切孔，自动计算其他切孔位置
                                float centerX = 65;
                                float centerY = 65;
                                float firstX = ListCutHole[0].Position.X;
                                float firstY = ListCutHole[0].Position.Y;
                                //距离
                                float distance = Convert.ToSingle(config.AppSettings.Settings["distance"].Value.ToString());
                                //矩阵 4*4
                                int rag = Convert.ToInt32(config.AppSettings.Settings["rag"].Value.ToString());
                                List<PointF> cutHolePoint = new List<PointF>();
                                //根据一个切孔点计算其他切孔信息
                                cutHolePoint = AnalysisPosition(centerX, centerY, firstX, firstY, distance, rag);
                                if (!FormHOZMainObject.m_MeasureFile.GetCutHolesFromAnalysisPosition(cutHolePoint))
                                {
                                    MessageBox.Show("生成切孔失败！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                                }
                                else
                                {
                                    //文件路径
                                    string CutHoleFilePath = FormHOZMainObject.m_MeasureFile.CutHoleFilePath;
                                    //重新获取切孔列表信息
                                    ListCutHole = FormHOZMainObject.m_MeasureFile.ListCutHole;
                                    //创建切孔列表信息
                                    FormHOZMainObject.CreateCutHoleList(ListCutHole);
                                    //显示导入的切孔数量
                                    lblCutHoleCount.Text = string.Format("成功生成{0}个切孔", ListCutHole.Count);
                                    tbCutHoleFilePath.Text = CutHoleFilePath;
                                }
                            }
                        }
                        //保存测量文件
                        if (FormHOZMainObject.IsSave)
                        {
                            FormHOZMainObject.m_MeasureFile.Save();
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                LogManager.LogError(ex.Message);
            }
        }
        private void pbCutHoleAuto_Click(object sender, EventArgs e)
        {
           
        }

        /// <summary>
        /// 分析点坐标
        /// </summary>
        /// <param name="centerX">中心点X轴坐标</param>
        /// <param name="centerY">中心点Y轴坐标</param>
        /// <param name="firstX">第一个点X轴坐标</param>
        /// <param name="firstY">第一个点Y轴坐标</param>
        /// <param name="distance">点与点的距离</param>
        /// <param name="rag">行、列数</param>
        /// <param name="ptsx">计算生成所有X轴坐标</param>
        /// <param name="ptsy">计算生成所有Y轴坐标</param>
        public List<PointF> AnalysisPosition(float centerX, float centerY, float firstX, float firstY, float distance, int rag)
        {
            //求样品1的水平角度
            double angle = 0;

            //清空所有点信息
            List<float> ptsx = new List<float>();
            List<float> ptsy = new List<float>();
            //将第一个点加入到点信息中
            ptsx.Add(firstX);
            ptsy.Add(firstY);

            //计算第一个点与X轴的交角度数
            angle = Math.Atan2(ptsy[0] - centerY, centerX - ptsx[0]) * 180 / Math.PI;

            //这里是求与第一个点横向排列的其他点的移动角度
            //就是按45度向左向右移动的度
            angle = 45 - angle;
            angle = angle * Math.PI / 180;

            float tx = 0;
            float ty = 0;
            for (int j = 0; j < rag; j++)
            {
                //计算每行第一个点的坐标
                if (j > 0)
                {
                    tx = (float)(distance * j * Math.Sin(angle));
                    ty = (float)(distance * j * Math.Cos(angle));
                    ptsx.Add(tx + ptsx[0]);
                    ptsy.Add(ptsy[0] - ty);
                }
                //计算每行其他点的坐标
                for (int i = 1; i < rag; i++)
                {
                    tx = (float)(distance * i * Math.Cos(angle));
                    ty = (float)(distance * i * Math.Sin(angle));
                    ptsx.Add(tx + ptsx[j * rag]);
                    ptsy.Add(ty + ptsy[j * rag]);
                }
            }
            List<PointF> pts = new List<PointF>();
            for (int i = 0; i < ptsx.Count; i++)
            {
                //增加的点
                PointF pf = new PointF();
                pf.X = ptsx[i];
                pf.Y = ptsy[i];
                pts.Add(pf);
            }
            return pts;
        }
        #endregion

        #region 加载PT模板文件
        private void btnPTTemplateFile_Click(object sender, EventArgs e)
        {
            string FilePathName;
            string fileNameWithoutExtension;
            //新建一个文件对话框
            OpenFileDialog pOpenFileDialog = new OpenFileDialog();
            //设置对话框标题
            pOpenFileDialog.Title = "选择模板文件";
            //默认目录
            pOpenFileDialog.InitialDirectory= @"\\192.168.1.101\fib auto\FIB Recipe\";
            //设置打开文件类型
            pOpenFileDialog.Filter = "ely文件（*.ely）|*.ely";
            ////监测文件是否存在
            //pOpenFileDialog.CheckFileExists = true;

            //文件打开后执行以下程序
            if (pOpenFileDialog.ShowDialog() == DialogResult.OK)
            {
                FilePathName = System.IO.Path.GetFullPath(pOpenFileDialog.FileName);  //绝对路径
                fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(FilePathName);
                this.txtWPTF.Text = FilePathName;
            }
        }
        private void pbTemplateFile_Click(object sender, EventArgs e)
        {
           
        }
        #endregion

        #region 加载FIB模板文件
        private void btnFIBTemplateFile_Click(object sender, EventArgs e)
        {
            string FilePathName;
            string fileNameWithoutExtension;
            //新建一个文件对话框
            OpenFileDialog pOpenFileDialog = new OpenFileDialog();
            //设置对话框标题
            pOpenFileDialog.Title = "选择模板文件";
            //默认目录
            pOpenFileDialog.InitialDirectory = @"\\192.168.1.101\fib auto\FIB Recipe\";
            //设置打开文件类型
            pOpenFileDialog.Filter = "ely文件（*.ely）|*.ely";
            ////监测文件是否存在
            //pOpenFileDialog.CheckFileExists = true;
            //文件打开后执行以下程序
            if (pOpenFileDialog.ShowDialog() == DialogResult.OK)
            {
                FilePathName = System.IO.Path.GetFullPath(pOpenFileDialog.FileName);  //绝对路径
                fileNameWithoutExtension = System.IO.Path.GetFileNameWithoutExtension(FilePathName);
                this.txtWFIBF.Text = FilePathName;
            }
        }
        private void pbFIBTemplateFile_Click(object sender, EventArgs e)
        {
           
        }
        #endregion

        #region 创建与读取样品参数、配置文件
        private void btnEditConfig_Click(object sender, EventArgs e)
        {
            DirectoryInfo TheFolder = new DirectoryInfo(System.Environment.CurrentDirectory + "\\SampleTemplate");
            Process pro = Process.Start(@"C:\Windows\notepad.exe", TheFolder.ToString()+ "\\" + cbbWYP.Text);//打开程序B

            
        }
        /// <summary>
        /// 获取测量参数，初始化窗体中的控件信息
        /// </summary>   
        /// <returns></returns>
        public bool GetMeasureParamFromHMI()
        {


            //从当前界面内获取参数
            var m_param = formHOZMain.m_MeasureFile.MParam;
            m_param.Is_Photograph = chkWIsP.Checked;//是否仅拍照
            m_param.PT = chkWPT.Checked;//是否有PT
            m_param.Tilt = chkWqxkc.Checked;//是否倾斜样品台
            m_param.EDS = chkEDS.Checked;
            m_param.EDSZ = Convert.ToSingle(txtEDSZ.Text) ;
            m_param.EDSV = Convert.ToSingle(txtEDSV.Text);
            m_param.EDSA = Convert.ToSingle(txtEDSA.Text) ;
            m_param.EDSParam.XrayCollectMode = Convert.ToInt16(cboXrayMode.Text);
            //自动对焦模式
            //cfm.FocusMode = chkManul.Checked;
            m_param.PTTemp = txtWPTF.Text;//PT文件路径
            m_param.FIBTemp = txtWFIBF.Text;//FIB文件路径
                                           



            m_param.ScanRotCor = Convert.ToSingle(txtScanRotCur.Text);
            m_param.PixelSizeCor = Convert.ToSingle(txtYPSCur.Text);



            m_param.SampleType = cbbWYP.Text;//样品类型
            m_param.Firm = cbbWCS.Text;//厂商类型
            return true;
        }

        
        /// <summary>
        /// 编辑confing 文件信息
        /// </summary>
        public bool SaveParamToConfigfile()
        {
            try
            {

                //厂商
                List<String> _firms = firms.ToList();
                if ((_firms.IndexOf(cbbWCS.Text) < 0)
                     || (!_firms.Contains(cbbWCS.Text)))
                {
                    _firms.Add(cbbWCS.Text);
                    string wFirms = string.Join(",", _firms.ToArray());
                    config.AppSettings.Settings["Firms"].Value = wFirms;
                }

                var m_Prm = formHOZMain.m_MeasureFile.MParam;


                config.AppSettings.Settings["Is_Photograph"].Value = m_Prm.Is_Photograph.ToString();
                config.AppSettings.Settings["PT_Depostion"].Value = m_Prm.PT.ToString();

                config.AppSettings.Settings["PT_ELYFile"].Value = m_Prm.PTTemp;
                config.AppSettings.Settings["FIB_ELYFile"].Value = m_Prm.FIBTemp;

                config.AppSettings.Settings["ScanRotCur"].Value = m_Prm.ScanRotCor.ToString();


                config.AppSettings.Settings["PixelSize_Y_Cur"].Value = m_Prm.PixelSizeCor.ToString();

                config.AppSettings.Settings["LastSampleType"].Value = m_Prm.SampleType;
           
              
                config.AppSettings.Settings["Is_Title"].Value = m_Prm.Tilt.ToString();

                config.AppSettings.Settings["Is_EDS"].Value = m_Prm.EDS.ToString();
                config.AppSettings.Settings["EDS_Z"].Value = m_Prm.EDSZ.ToString();
                config.AppSettings.Settings["EDS_V"].Value = m_Prm.EDSV.ToString();
                config.AppSettings.Settings["EDS_A"].Value = m_Prm.EDSA.ToString();
                

                config.Save(ConfigurationSaveMode.Full);
                ConfigurationManager.RefreshSection("appSettings");//重新加载新的配置文件
                return true;
            }
            catch (Exception ex)
            {
                LogManager.LogError(ex.Message);
                return false;
            }
        }

      

        /// <summary>
        /// 绑定下拉菜单
        /// </summary>
        /// <param name="cb"></param>
        /// <param name="strGroup"></param>
        private void BindComboxData(ComboBox cb, string[] strGroup)
        {
            for (int i = 0; i < strGroup.Length; i++)
            {
                if (!strGroup[i].Equals(""))
                {
                    cb.Items.Add(strGroup[i]);
                }
            }
        }

        /// <summary>
        /// 读取Config文件信息
        /// </summary>
        public void DisplayInitialParam()
        {
            cbbWYP.Items.Clear();
            cbbWCS.Items.Clear();

            string firm = config.AppSettings.Settings["Firms"].Value.ToString();

            string ScanRotCur = config.AppSettings.Settings["ScanRotCur"].Value.ToString();

            txtScanRotCur.Text = ScanRotCur;
            txtYPSCur.Text= config.AppSettings.Settings["PixelSize_Y_Cur"].Value.ToString();
            //厂商
            firms = firm.Split(',');
            BindComboxData(cbbWCS, firms);


           

            //设置配置文件默认值
            chkWIsP.Checked=Convert.ToBoolean(config.AppSettings.Settings["Is_Photograph"].Value);
            chkWPT.Checked = Convert.ToBoolean(config.AppSettings.Settings["PT_Depostion"].Value);
         
            chkWqxkc.Checked = Convert.ToBoolean(config.AppSettings.Settings["Is_Title"].Value);

            txtWPTF.Text = config.AppSettings.Settings["PT_ELYFile"].Value;
            txtWFIBF.Text = config.AppSettings.Settings["FIB_ELYFile"].Value;
          
    
            cbbWYP.Text = config.AppSettings.Settings["LastSampleType"].Value;
            cbbWCS.Text = config.AppSettings.Settings["LastSelectFirm"].Value;
            
            chkEDS.Checked = Convert.ToBoolean(config.AppSettings.Settings["Is_EDS"].Value);
            txtEDSZ.Text= Convert.ToString(config.AppSettings.Settings["EDS_Z"].Value);
            txtEDSV.Text = Convert.ToString(config.AppSettings.Settings["EDS_V"].Value);
            txtEDSA.Text = Convert.ToString(config.AppSettings.Settings["EDS_A"].Value);
            cboXrayMode.Text = Convert.ToString(config.AppSettings.Settings["EDS_XrayMode"].Value);
        }

        /// <summary>
        /// 根据所选路径，读取模板文件
        /// </summary>
        public void ReadConfigInfo()
        {
            if (!ReadConfigPath.Equals(""))
            {
                DisplayInitialParam();
                ConfigFile cfm = new ConfigFile(FormHOZMainObject.m_MeasureFile.MParam);
                cfm.Read(ReadConfigPath);
                chkWIsP.Checked = cfm.m_Config.Is_Photograph;
                chkWPT.Checked = cfm.m_Config.PT;
                //自动对焦模式
                //cfm.FocusMode = chkManul.Checked;
                txtWPTF.Text = cfm.m_Config.PTTemp;
                txtWFIBF.Text = cfm.m_Config.FIBTemp;

                cbbWYP.Text = cfm.m_Config.SampleType;
                cbbWCS.Text = cfm.m_Config.Firm;
            }
        }

        /// <summary>
        /// 修改配置文件默认值
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSaveDefalutPara_Click(object sender, EventArgs e)
        {
            if (chkWPT.Checked)
            {
                if (txtWPTF.Text == "")
                {
                    MessageBox.Show("PT文件路径不能为空");
                    return;
                }
            }
            if (txtWFIBF.Text == "")
            {
                MessageBox.Show("FIB文件路径不能为空");
                return;
            }


            GetMeasureParamFromHMI();

            SaveParamToConfigfile();

            //获取测量结果文件位置，并保存测量结果文件
            if (formHOZMain.m_MeasureFile.SaveAs())
            {

                //设置已保存状态
                formHOZMain.IsSave = true;
            }

           



            FormHOZMainObject.m_MeasureFile.IsModified = true;


       
            Form fParent = this.ParentForm;
            fParent.Close();
        }
        #endregion

        #region 删除下拉菜单选择项

       

        #endregion

        #region 根据是否仅拍照，进行逻辑判断
        private void chkWIsP_CheckedChanged(object sender, EventArgs e)
        {
            if (chkWIsP.Checked)
            {
                chkWqxkc.Checked = false;
                chkWqxkc.Visible = false;
                chkWPT.Checked = false;
                chkWPT.Visible = false;
                label61.Visible = false;
                label59.Visible = false;
                txtWFIBF.Visible = false;
                txtWPTF.Visible = false;
                btnPTTemplateFile.Visible = false;
                btnFIBTemplateFile.Visible = false;
                //label58.Visible = false;
                //cbbWXZ.Visible = false;
                chkEDS.Visible = false;
                //label18.Visible = false;
                //label19.Visible = false;
                //txtEDSZ.Visible = false;
                //cbbWFIB.Visible = false;
                //pbDelWFIB.Visible = false;
                FormHOZMainObject.m_MeasureType = (int)MeasureMsgManage.measureType.Photo;
            }
            else
            {
                chkWqxkc.Visible = true;
                chkWPT.Visible = true;
                label61.Visible = true;
                label59.Visible = true;
                txtWFIBF.Visible = true;
                txtWPTF.Visible = true;
                btnPTTemplateFile.Visible = true;
                btnFIBTemplateFile.Visible = true;
                //label58.Visible = true;
                //cbbWXZ.Visible = true;
                chkEDS.Visible = true;
                //label2.Visible = true;
                //cbbWFIB.Visible = true;
                //pbDelWFIB.Visible = true;
                //label18.Visible = true;
                //label19.Visible = true;
                //txtEDSZ.Visible = true;
                if (!chkWPT.Checked)
                {
                    FormHOZMainObject.m_MeasureType = (int)MeasureMsgManage.measureType.FIB;
                }
            }
            CreateCutHoleList();
        }
        #endregion

       

        #region 创建切孔列表
        private void CreateCutHoleList()
        {
            List<CutHole> ListCutHole = FormHOZMainObject.m_MeasureFile.ListCutHole;
            FormHOZMainObject.CreateCutHoleList(ListCutHole);
        } 
        #endregion

        #region 设置流程类型
        private void chkWPT_CheckedChanged(object sender, EventArgs e)
        {
            if (chkWPT.Checked)
            {
                FormHOZMainObject.m_MeasureType = (int)MeasureMsgManage.measureType.PT;
            }
            else
            {
                if (!chkWIsP.Checked)
                {
                    FormHOZMainObject.m_MeasureType = (int)MeasureMsgManage.measureType.FIB;
                }
            }
            CreateCutHoleList();
        } 
        #endregion

        #region 关闭按钮 鼠标操作事件
        private void pbClose_MouseEnter(object sender, EventArgs e)
        {
            pbClose.BackgroundImage = global::HOZProject.Properties.Resources.exit_2_;
        }

        private void pbClose_MouseLeave(object sender, EventArgs e)
        {
            pbClose.BackgroundImage = global::HOZProject.Properties.Resources.exit_2_;
        }
        #endregion

        #region 输入限制只能是数字
        private void textBox_KeyPress(string text, object sender, KeyPressEventArgs e)
        {
            //判断按键是不是要输入的类型。
            if (((int)e.KeyChar < 48 || (int)e.KeyChar > 57) && (int)e.KeyChar != 8 && (int)e.KeyChar != 46)
                e.Handled = true;
            //小数点的处理。
            if ((int)e.KeyChar == 46) //小数点
            {
                if (text.Length <= 0)
                    e.Handled = true; //小数点不能在第一位
                else
                {
                    float f;
                    float oldf;
                    bool b1 = false, b2 = false;
                    b1 = float.TryParse(text, out oldf);
                    b2 = float.TryParse(text + e.KeyChar.ToString(), out f);
                    if (b2 == false)
                    {
                        if (b1 == true)
                            e.Handled = true;
                        else
                            e.Handled = false;
                    }
                }
            }
        }

        private void ComboBox_KeyPress(string text, object sender, KeyPressEventArgs e)
        {

            //允许输入数字、小数点、删除键和负号  
            if ((e.KeyChar < 48 || e.KeyChar > 57) && e.KeyChar != 8 && e.KeyChar != (char)('.') && e.KeyChar != (char)('-'))
            {
                MessageBox.Show("请输入正确的数字");
                text = "";
                e.Handled = true;
            }
            if (e.KeyChar == (char)('-'))
            {
                if (text != "")
                {
                    MessageBox.Show("请输入正确的数字");
                    text = "";
                    e.Handled = true;
                }
            }
            //小数点只能输入一次  
            if (e.KeyChar == (char)('.') && ((ComboBox)sender).Text.IndexOf('.') != -1)
            {
                MessageBox.Show("请输入正确的数字");
                text = "";
                e.Handled = true;
            }
            //第一位不能为小数点  
            if (e.KeyChar == (char)('.') && ((ComboBox)sender).Text == "")
            {
                MessageBox.Show("请输入正确的数字");
                text = "";
                e.Handled = true;
            }
            //第一位是0，第二位必须为小数点  
            if (e.KeyChar != (char)('.') && ((ComboBox)sender).Text == "0")
            {
                MessageBox.Show("请输入正确的数字");
                text = "";
                e.Handled = true;
            }
            //第一位是负号，第二位不能为小数点  
            if (((ComboBox)sender).Text == "-" && e.KeyChar == (char)('.'))
            {
                MessageBox.Show("请输入正确的数字");
                text = "";
                e.Handled = true;
            }
        }

        //private void cbbWPZD_KeyPress(object sender, KeyPressEventArgs e)
        //{
        //    ComboBox_KeyPress(cbbWPZD.Text, sender, e);
        //}

        //private void cbbWPZF_KeyPress(object sender, KeyPressEventArgs e)
        //{
        //    ComboBox_KeyPress(cbbWPZF.Text, sender, e);
        //}

        //private void cbbWQGD_KeyPress(object sender, KeyPressEventArgs e)
        //{
        //    ComboBox_KeyPress(cbbWQGD.Text, sender, e);
        //}

        //private void cbbWQGF_KeyPress(object sender, KeyPressEventArgs e)
        //{
        //    ComboBox_KeyPress(cbbWQGF.Text, sender, e);
        //}

        //private void cbbWLZ_KeyPress(object sender, KeyPressEventArgs e)
        //{
        //    ComboBox_KeyPress(cbbWLZ.Text, sender, e);
        //}

        #endregion

        #region Z轴的保护范围
        private void chkWqxkc_CheckedChanged(object sender, EventArgs e)
        {
            //if (chkWqxkc.Checked) 
            //{
            //    label3.Visible = true;
            //    cbbYDZZDX.Visible = true;
            //}
            //else
            //{
            //    label3.Visible = false;
            //    cbbYDZZDX.Visible = false;
            //}
        }

        //private void txtYPSCur_TextChanged(object sender, EventArgs e)
        //{
        //    if (txtYPSCur.Text != "")
        //    {
        //        if (Convert.ToSingle(txtYPSCur.Text) > 5)
        //        {
        //            MessageBox.Show("数值最大为5");
        //            txtYPSCur.Text = "5";
        //        }
        //    }
        //    else
        //    {
        //        txtYPSCur.Text = "1";
        //    }

        //}

        private void txtYPSCur_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (((int)e.KeyChar < 48 || (int)e.KeyChar > 57) && (int)e.KeyChar != 8 && (int)e.KeyChar != 46)
            {
                e.Handled = true;
            }
        }
        #endregion
        
        #region 参数确认
        private void SaveMeasureFile()
        {
            //界面上的参数
            GetMeasureParamFromHMI();
            //配置文件中的参数
            //FormHOZMainObject.m_MeasureFile.MParam.ZDistance = Convert.ToSingle(ConfigurationManager.AppSettings["ZDistance"].ToString());



            FormHOZMainObject.m_MeasureFile.IsModified = true;


            if (Directory.Exists(FormHOZMainObject.m_MeasureFile.FilePath))//如果已经存在硬盘上要重新保存文件
            {
                FormHOZMainObject.m_MeasureFile.Save();
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            //保存测量文件的参数
            SaveMeasureFile();
        }


        #endregion

       


       


        private void btnHandSavePoints_Click(object sender, EventArgs e)
        {
            UserControls.FormExportPoints uCExport = new UserControls.FormExportPoints();
            uCExport.ShowDialog();
            List<CutHole> ListCutHole = uCExport.ListCutHole;
            //文件路径
            //string CutHoleFilePath = FormHOZMainObject.m_MeasureFile.CutHoleFilePath;
            FormHOZMainObject.CreateCutHoleList(ListCutHole);
            FormHOZMainObject.m_MeasureFile.ListCutHole = ListCutHole;
            //显示导入的切孔数量
            lblCutHoleCount.Text = string.Format("成功导入{0}个切孔", ListCutHole.Count);
            //tbCutHoleFilePath.Text = CutHoleFilePath;
            //保存测量文件
            if (Directory.Exists(FormHOZMainObject.m_MeasureFile.FilePath))
            {
                FormHOZMainObject.m_MeasureFile.Save();
            }
        }
        
        private void cbbWYP_SelectedIndexChanged(object sender, EventArgs e)
        {
            
                FormHOZMainObject.m_MeasureFile.MParam.loadParamFromSampleTypeTemplate(cbbWYP.Text);
                SetTypel();
          
           
        }
        private void SetTypel()
        {
            //if (cbbWYP.Text == "0")
            //{
            //cbbWCS.Text = FormHOZMainObject.m_MeasureFile.MParam.VendorType0;//厂商

            txtVot.Text = FormHOZMainObject.m_MeasureFile.MParam.Voltage.ToString();//电压
            txtIprobe.Text = FormHOZMainObject.m_MeasureFile.MParam.Iprobe.ToString();

            txtMag1.Text = FormHOZMainObject.m_MeasureFile.MParam.Location_Magnification.ToString();//定位放大倍数
            txtMag2.Text = FormHOZMainObject.m_MeasureFile.MParam.Straighten_Magnification.ToString();//拉直放大倍数
            txtMag3.Text = FormHOZMainObject.m_MeasureFile.MParam.FindCrossMagnification.ToString();

            //cbbWPZD.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoVoltageeType0;//拍照电压
            txtMag4.Text = FormHOZMainObject.m_MeasureFile.MParam.Photograph_Magnification.ToString();//拍照放大倍数
                //cbbEDSV.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMVoltageeType0;//能谱电压值
                //cbbEDSA.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMCurrentType0;//能谱电流值
            //    label4.Text = "0-AA Hole";
            //}
            //else
            //            if (cbbWYP.Text == "1")
            //{
            //    //cbbWCS.Text = FormHOZMainObject.m_MeasureFile.MParam.VendorType1;//厂商
            //    cbbWLZ.Text = FormHOZMainObject.m_MeasureFile.MParam.StraightenTimesType1;//拉直放大倍数
            //    cbbWQGD.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningVoltageeType1;//定位电压
            //    cbbWQGF.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningTimesType1;//定位放大倍数
            //    cbbWPZD.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoVoltageeType1;//拍照电压
            //    cbbWPZF.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoTimesType1;//拍照放大倍数
            //    cbbEDSV.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMVoltageeType1;//能谱电压值
            //    cbbEDSA.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMCurrentType1;//能谱电流值
            //    label4.Text = "1-AA区";
            //}
            //else
            //            if (cbbWYP.Text == "2")
            //{
            //    //cbbWCS.Text = FormHOZMainObject.m_MeasureFile.MParam.VendorType2;//厂商
            //    cbbWLZ.Text = FormHOZMainObject.m_MeasureFile.MParam.StraightenTimesType2;//拉直放大倍数
            //    cbbWQGD.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningVoltageeType2;//定位电压
            //    cbbWQGF.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningTimesType2;//定位放大倍数
            //    cbbWPZD.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoVoltageeType2;//拍照电压
            //    cbbWPZF.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoTimesType2;//拍照放大倍数
            //    cbbEDSV.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMVoltageeType2;//能谱电压值
            //    cbbEDSA.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMCurrentType2;//能谱电流值
            //    label4.Text = "2-Pad bending";
            //}
            //else
            //            if (cbbWYP.Text == "3")
            //{
            //    //cbbWCS.Text = FormHOZMainObject.m_MeasureFile.MParam.VendorType3;//厂商
            //    cbbWLZ.Text = FormHOZMainObject.m_MeasureFile.MParam.StraightenTimesType3;//拉直放大倍数
            //    cbbWQGD.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningVoltageeType3;//定位电压
            //    cbbWQGF.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningTimesType3;//定位放大倍数
            //    cbbWPZD.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoVoltageeType3;//拍照电压
            //    cbbWPZF.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoTimesType3;//拍照放大倍数
            //    cbbEDSV.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMVoltageeType3;//能谱电压值
            //    cbbEDSA.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMCurrentType3;//能谱电流值
            //    label4.Text = "3-DDIC";
            //}
            //else
            //            if (cbbWYP.Text == "4")
            //{
            //    //cbbWCS.Text = FormHOZMainObject.m_MeasureFile.MParam.VendorType3;//厂商
            //    cbbWLZ.Text = FormHOZMainObject.m_MeasureFile.MParam.StraightenTimesType4;//拉直放大倍数
            //    cbbWQGD.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningVoltageeType4;//定位电压
            //    cbbWQGF.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningTimesType4;//定位放大倍数
            //    cbbWPZD.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoVoltageeType4;//拍照电压
            //    cbbWPZF.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoTimesType4;//拍照放大倍数
            //    cbbEDSV.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMVoltageeType4;//能谱电压值
            //    cbbEDSA.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMCurrentType4;//能谱电流值
            //    label4.Text = "4-射频IC-1";
            //}
            //else
            //            if (cbbWYP.Text == "5")
            //{
            //    //cbbWCS.Text = FormHOZMainObject.m_MeasureFile.MParam.VendorType3;//厂商
            //    cbbWLZ.Text = FormHOZMainObject.m_MeasureFile.MParam.StraightenTimesType5;//拉直放大倍数
            //    cbbWQGD.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningVoltageeType5;//定位电压
            //    cbbWQGF.Text = FormHOZMainObject.m_MeasureFile.MParam.PositioningTimesType5;//定位放大倍数
            //    cbbWPZD.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoVoltageeType5;//拍照电压
            //    cbbWPZF.Text = FormHOZMainObject.m_MeasureFile.MParam.PhotoTimesType5;//拍照放大倍数
            //    cbbEDSV.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMVoltageeType5;//能谱电压值
            //    cbbEDSA.Text = FormHOZMainObject.m_MeasureFile.MParam.SEMCurrentType5;//能谱电流值
            //    label4.Text = "5-射频IC-1";
            //}
        }
    }
}
